import traceback

from sanic import response
from sanic import exceptions as exc
from IzzyLib import logging

from .database import db
from .functions import Error


@exc.add_status_code(418)
class Teapot(exc.SanicException):
	pass


def generic(request, exception):
	try:
		status = exception.status_code
	except:
		status = 500

	if status == 400:
		print(exception)

	return Error(request, status, str(exception))


def server_error(request, exception):
	if not request:
		logging.debug('Empty request')
		return

	traceback.print_exc()
	msg = 'OOPSIE WOOPSIE!! Uwu We made a fucky wucky!! A wittle fucko boingo! The code monkeys at our headquarters are working VEWY HAWD to fix this!'
	return Error(request, 500, msg)


def orm_detached_instance(request, exception):
	msg = 'Sqlalchemy is fucking up again :/'
	#return response.text(msg, status=500)
	return Error(request, 500, msg)


def missing_template(request, exception):
	logging.error(f'This template is missing: {exception}, {request.path}')
	msg = f'I\'m a dumbass and forgot to create this template: {str(exception)}'
	return response.text(msg, status=500)
