const login_value = document.getElementById("login_value").value
const encodedMessage = enc.encode('hello');
const localStorage.setItem('privkey', privateKey);
const localStorage.setItem('pubkey', publicKey);


var privateKey;
var publicKey;


var iv;


function asciiToUint8Array(str) {
	var chars = [];
	for (var i = 0; i < str.length; ++i)
		chars.push(str.charCodeAt(i));
	return new Uint8Array(chars);
}

function RSAPSS_Sign(plainText) {
	var cryptoObj = window.crypto || window.msCrypto;

	if(!cryptoObj)
	{
		alert("Crypto API is not supported by the Browser");
		return;
	}

	window.crypto.subtle.generateKey({
				name: 'RSA-PSS',
				modulusLength: 2048, //can be 1024, 2048, or 4096
				publicExponent: new Uint8Array([0x01, 0x00, 0x01]),
				hash: {name: 'SHA-256'},
			},
			true,
			['sign', 'verify']
		)
		.then(function(key) {

			publicKey = key.publicKey;
			privateKey = key.privateKey;
			// For Demo Purpos Only Exported in JWK format
			window.crypto.subtle.exportKey('jwk', key.publicKey).then(
				function(keydata) {
					publicKeyhold = keydata;
					publicKeyJson = JSON.stringify(publicKeyhold);
					document.getElementById("rsapublic").value = publicKeyJson;
				}
			);

			window.crypto.subtle.exportKey("jwk", key.privateKey).then(
				function(keydata) {
					privateKeyhold = keydata;
					privateKeyJson = JSON.stringify(privateKeyhold);
					document.getElementById("rsaprivate").value = privateKeyJson;
				}
			);

			window.crypto.subtle.sign({
						name: "RSA-PSS",
						saltLength: 128, //the length of the salt
					},
					privateKey, //from generateKey or importKey above
					asciiToUint8Array(plainText) //ArrayBuffer of data you want to sign
				)
				.then(function(signature) {
					//returns an ArrayBuffer containing the signature
					document.getElementById("cipherText").value = bytesToHexString(signature);
				})
				.catch(function(err) {
					console.error(err);
				});


		})
		.catch(function(err) {
			console.error(err);
		});
}
	


function RSAPSS_Verify() {
	var cryptoObj = window.crypto || window.msCrypto;

	if(!cryptoObj)
	{
		alert("Crypto API is not supported by the Browser");
		return;
	}
	
	var cipherText = document.getElementById("cipherText").value;
	var plainText = document.getElementById("plainText").value;

	if(!publicKey)
	{
		alert("Generate RSA-PSS Keys First")
		return;
	}

	window.crypto.subtle.verify({
				name: "RSA-PSS",
				saltLength: 128, //the length of the salt
			},
			publicKey, //from generateKey or importKey above
			hexStringToUint8Array(cipherText), //ArrayBuffer of the data
			asciiToUint8Array(plainText)
		)
		.then(function(decrypted) {
			alert("Verified   " + decrypted);
		})
		.catch(function(err) {
			console.error(err);
		});

}

function bytesToASCIIString(bytes) {
	return String.fromCharCode.apply(null, new Uint8Array(bytes));
}

function bytesToHexString(bytes) {
	if (!bytes)
		return null;

	bytes = new Uint8Array(bytes);
	var hexBytes = [];

	for (var i = 0; i < bytes.length; ++i) {
		var byteString = bytes[i].toString(16);
		if (byteString.length < 2)
			byteString = "0" + byteString;
		hexBytes.push(byteString);
	}

	return hexBytes.join("");
}

function hexStringToUint8Array(hexString) {
	if (hexString.length % 2 != 0)
		throw "Invalid hexString";
	var arrayBuffer = new Uint8Array(hexString.length / 2);

	for (var i = 0; i < hexString.length; i += 2) {
		var byteValue = parseInt(hexString.substr(i, 2), 16);
		if (byteValue == NaN)
			throw "Invalid hexString";
		arrayBuffer[i / 2] = byteValue;
	}

	return arrayBuffer;
}


function failAndLog(error) {
	console.log(error);
	alert(error);
}


function sign_uuid() {
	var uuid = document.getElementById("plainText").value;
}


form.addEventListener('submit', function(e) {
	e.preventDefault();
});


function generate_key() {
	keypair = window.crypto.subtle.generateKey(
		{
			name: 'RSA-PSS',
			modulusLength: 2048, //can be 1024, 2048, or 4096
			publicExponent: new Uint8Array([0x01, 0x00, 0x01]),
			hash: {name: 'SHA-256'},
		},
		true,
		['sign', 'verify']
	)

	return keypair.then(function(key) {
		publicKey = key.publicKey;
		privateKey = key.privateKey;
		privkey = window.crypto.subtle.exportKey('jwk', key.publicKey)

		return privkey.then(
			function(keydata) {
				publicKeyhold = keydata;
				publicKeyJson = JSON.stringify(publicKeyhold);
				return publicKeyJson;
			}
		);
	});
};

generate_key()
